#!/usr/bin/perl

##############################################################################
# smbstatus2html.pl (C) RvB <rvb@rvb-net.yi.org>                             #
# This script is free software. You may redistribute and/or modify  it under #
# the terms and conditions of the GNU General Public License, Version 2      #
#                                                                            #
# There is NO WARRANTY on anything!                                          #
##############################################################################
#
# ----------------- Anzeige der Lehrer verhindern ---------------------------#
#
# Hier die Benutzergruppen eintragen, die nicht angezeigt werden sollen. 
# Falls z.B. die Lehrer nicht angezeigt werden sollen, loeschen Sie in der 
# naechsten Zeile das '#'. 
# @invisible_groups = ("lehrer");
#
# ----------------- statische IP-Adressen beachten --------------------------#
#
# Hier besteht die Möglichkeit festzulegen, dass bei Verwendung von festen 
# IP-Adressen alle dynamisch vergebenen rot hervorgehoben dargestellt werden.
# Dazu geht das Script davon aus, dass für die fest vergebenen IP-Adressen 
# fuer jedes Teilnetz die letzte Komponente < 40 gilt.
# Bei mehreren Teilnetzen ist dazu die dhcpd.conf anzupassen
# Wenn Sie also unter diesen Bedingungen diese Möglichkeit nutzen wollen,
# entfernen Sie in der nM-dchsten Zeile das '#'.
# $exist_static = 1 ;
#
# Hier kann eingestellt werden welche 
# Teilnetze angezeigt werden sollen
#

@suchbereich=("0","1","100");

# ------------------ Zuweisung von Namen f|r Teilnetze ---------------------#

# Hier können Sie verschiedenen Teilnetzen (beginnend ab 0) einen Namen
# zuordnen. Dies kann nötzlich sein um das Script mit 
# smbstatus2html.pl?Kabinett aufzurufen und somit nur das Teilnetz für
# "Kabinett" anzuzeigen. Ein Beispiel steht unter diesen Kommentaren. Es muss
# in einer zeile immer ein Paar wie "Name", "Teilnetznummer", stehen. Beim 
# letzten Paar bitte das Komma hinter der Teilnetznummer weglassen.

%Teilnetze = (

	"Kolleg", "0",
	"WLAN", "1",
	"BA", "9"

);

# ----------------- Ende des Konfigurationsbereiches -----------------------#


# Hier wird konfiguriert über welche datei der Datenaustausch gemacht wird
$smbstatus_file = "/tmp/smbstatus2html.smbstatus_output";
$date = `/bin/date \"+%T %e.%m.%Y\"`;
system "smbstatus -b > $smbstatus_file";

open SMB_OUTPUT, "< $smbstatus_file";
@smb_output = <SMB_OUTPUT>;
close (SMB_OUTPUT);

print "Content-type: text/html\n\n";
print "<HTML><BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\"\
BACKGROUND=\"/online/whttxtr2.jpg\"><H1>Folgende\
Benutzer sind im System:</H1><FONT SIZE=\"-1\">Datum: $date</FONT><BR>\n";

$teilnetzname = $ENV{'QUERY_STRING'};



 if($teilnetzname ne "") {@suchbereich=("0");}

foreach $teilnetz (@suchbereich)

{

 if($teilnetzname ne "")
 {
	$teilnetz = $Teilnetze{$teilnetzname};
	$teilnetze = $Teilnetze{$teilnetzname};
	print "<font size=\"+2\">".$teilnetzname."</font><BR>\n";
 }
 else
 {
	print "<font size=\"+2\">Teilnetz: 192.168.".$teilnetz.".0</font><BR>\n";
 }

 print "<TABLE BORDER=\"1\" WIDTH=\"100%\">";
 print "<TR BGCOLOR=\"#D0D0D0\"><TH>";
 print "Arbeitsplatz</TH><TH>IP-Adresse</TH><TH>Account";
 print "</TH></TR>";

 @warenda = ();
 $skiprest=0;

 foreach $line (@smb_output)
 {
	if($skiprest==1){goto eo_foreach;}
	$line =~ s/\n//i;
	$line =~ s/^ *//;
	if($line=~/^\s*$/) {goto eo_foreach;}
	if($line=~/Samba version/) {goto eo_foreach;}
	if($line=~/PID *Username *Group *Machine/) {goto eo_foreach;}
	if($line=~/---*/) {goto eo_foreach;}
	if($line=~/[Ll]ocked *files/){$skiprest=1;goto eo_foreach;}
	$line =~ s/[\)\(]//g;
	@fields = split(/ +/,$line);
	@ipparts = split(/\./,$fields[4]);

	foreach $invisible (@invisible_groups)
	{
		if($fields[2] eq $invisible)
		{
			goto eo_foreach;
		}
	}
	foreach $dawarer (@warenda)
	{
		if($fields[1]." | ".$fields[4] eq $dawarer)
		{
		
			goto eo_foreach;
			
		}
	}
	if($ipparts[2] == $teilnetz)
	{
		if($ipparts[3] > 41 and $exist_static == 1)
		{
			print "<tr><td>$fields[3]</td><td><font color=\"#FF0000\"><b>\
$fields[4]</b></font></td><td><A HREF=\"mailto:$fields[1]\@arktur\">$fields[1]</A></td></tr>";
		}
		else
		{
			print "<tr><td>$fields[3]</td><td>$fields[4]</td>\
<td><A HREF=\"mailto:$fields[1]\@arktur\">$fields[1]</td></tr>";
		}
	}

	push(@warenda,$fields[1]." | ".$fields[4]);
	eo_foreach:
 }
 print "</TABLE><BR>";

}




print "<br>smbstatus2html.cgi Version 0.7 Mai 2006, <br> \ 
f&uuml;r Arktur 4 von <A HREF=\"mailto:superlehrer\@gmx.de\">J. Fiebig</A> vom\
<A HREF=\"http://www.Erzgebirgskolleg.de\">Erzgebirgskolleg Breitenbrunn</A>.<BR>
</BODY></HTML>";



exit 1;
